#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <clientprefs>

#define MAX_SOUNDS 100
#define PLUGIN_VERSION "2.2b"

#define GAME_CSTRIKE 1

new Handle:g_CvarEnabled = INVALID_HANDLE;
new Handle:AtRoundEnd = INVALID_HANDLE;
new Handle:AtRoundStart = INVALID_HANDLE;
new Handle:OnPlayerConnect = INVALID_HANDLE;
new Handle:Timer;
new Handle:AnnounceEvery;
new Handle:RandomSound;
new Handle:cookieResPref;

new bool:roundEnded = false;

new String:g_soundsListCT[MAX_SOUNDS][PLATFORM_MAX_PATH];
new String:g_soundsListT[MAX_SOUNDS][PLATFORM_MAX_PATH];
new String:g_soundsList[MAX_SOUNDS][PLATFORM_MAX_PATH];
new String:SoundList[PLATFORM_MAX_PATH];

static String:Team1[4][4]  = {"T","RED","GER","IRQ"};
static String:Team2[3][4]  = {"CT","BLU","USA"};

new res_sound[MAXPLAYERS + 1];

new MaxSounds;
new MaxSoundsCT;
new MaxSoundsT;
new rnd_sound;
new ev_winner;
new game;

//------------------------------------------------------------------------------------------------------------------------------------
// Colors
#define YELLOW               "\x01"
#define NAME_TEAMCOLOR       "\x02"
#define TEAMCOLOR            "\x03"
#define GREEN                "\x04"
//------------------------------------------------------------------------------------------------------------------------------------

public Plugin:myinfo =
{
	name = "Round End Sound",
	author = "FrozDark",
	description = "Plays a random sound or the sound of the winner team at round end",
	version = PLUGIN_VERSION,
	url = "http://www.all-stars.sytes.net/"
};


public OnPluginStart(){
	g_CvarEnabled = CreateConVar("sm_res_enable", "1", "Enable/disable round end sound");
	AtRoundEnd = CreateConVar("sm_res_roundendannounce", "0", "Announcement at every round end");
	AtRoundStart = CreateConVar("sm_res_roundstartannounce", "0", "Announcement at every round start");
	OnPlayerConnect = CreateConVar("sm_res_playerconnectannounce", "1", "Announcement in 20 sec. after player connect");
	AnnounceEvery = CreateConVar("sm_res_announceevery", "120", "How often in seconds it will display the message every time. 0=Disable");
	RandomSound = CreateConVar("sm_res_randomsound", "0", "If disabled it will play sounds of winner team, if enabled all sounds will be random");
	
	decl String:dir[15];
	decl String:desc[64];
	GetGameFolderName(dir, sizeof(dir));
	GetGameDescription(desc, sizeof(desc), true);
	
	if (StrEqual(dir,"cstrike",false) || StrEqual(dir,"cstrike_beta",false)) game = GAME_CSTRIKE;
	
	LogAction(0, -1, "%s detected. Access successful", desc);
	
	HookEvent("round_end", OnRoundEnd);
	HookEvent("round_start", OnRoundStart);

	LoadTranslations("common.phrases");
	LoadTranslations("plugin.res");
	LoadResSounds();
	
	RegConsoleCmd("res", ResCmd, "On/Off Round End Sounds");
	
	HookConVarChange(AnnounceEvery, ConVarChange_Timer);
	
	AutoExecConfig(true, "plugin.res");
	CreateConVar("sm_res_version", PLUGIN_VERSION, "Round End Sound version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);
	
	cookieResPref = RegClientCookie("Round End Sound", "Round End Sound", CookieAccess_Private);
	new info;
	SetCookieMenuItem(ResPrefSelected, any:info, "Round End Sound");
}

public OnMapStart() {	
	if(!GetConVarBool(g_CvarEnabled)) return;
	for(new i = 1; i <= MaxSounds; i++) PrepareSound(i);
	Timer = CreateTimer(GetConVarFloat(AnnounceEvery), TimerEvery, _, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
}

public ConVarChange_Timer(Handle:convar, const String:oldValue[], const String:newValue[]) {
    if (Timer != INVALID_HANDLE) KillTimer(Timer);
    
    Timer = CreateTimer(GetConVarFloat(AnnounceEvery), TimerEvery, _, TIMER_REPEAT|TIMER_FLAG_NO_MAPCHANGE);
}

public OnRoundStart(Handle:event, const String:name[], bool:dontBroadcast) {
	roundEnded = false;
	if(GetConVarBool(AtRoundStart)) PrintToChatAll("\x04[\x01RoundEndSound\x04] %t", "Announce Message", YELLOW, GREEN, YELLOW, GREEN);
}

public OnRoundEnd(Handle:event, const String:name[], bool:dontBroadcast){
	if(!GetConVarBool(g_CvarEnabled)) return;
	roundEnded = true;
	for (new i = 1; i <= MaxClients; i++) {
		if(IsClientInGame(i) && !IsFakeClient(i) && res_sound[i] != 0) {
			if(game == GAME_CSTRIKE)
			{
				StopSound(i, SNDCHAN_STATIC, "radio/ctwin.wav");
				StopSound(i, SNDCHAN_STATIC, "radio/terwin.wav");
			}
			ev_winner = GetEventInt(event, "winner");
			
			if(!GetConVarBool(RandomSound))
			{
				if(ev_winner == 2)
				{
					rnd_sound = GetRandomInt(1, MaxSoundsT);
					EmitSoundToClient(i, g_soundsListT[rnd_sound]);
				}
				else if(ev_winner == 3) 
				{
					rnd_sound = GetRandomInt(1, MaxSoundsCT);
					EmitSoundToClient(i, g_soundsListCT[rnd_sound]);
				}
			}
			else if(ev_winner != 1)
			{
				rnd_sound = GetRandomInt(1, MaxSounds);
				EmitSoundToClient(i, g_soundsList[rnd_sound]);
			}
		}
		if(GetConVarBool(AtRoundEnd)) PrintToChat(i, "\x04[\x01RoundEndSound\x04] %t", "Announce Message", YELLOW, GREEN, YELLOW, GREEN);
	}
}

LoadResSounds()
{
	decl String:Line[512];
	decl String:Text[2][256];
	decl String:Text2[256];
	BuildPath(Path_SM,SoundList,sizeof(SoundList),"configs/res_list.cfg");
	if(!FileExists(SoundList))
	{
		LogMessage("res_list.cfg not parsed... file doesn't exist! Unloading...");
		InsertServerCommand("sm plugins unload RoundEndSound.smx");
	}
	new Handle:filehandle = OpenFile(SoundList, "r");

	while(!IsEndOfFile(filehandle))
	{
		ReadFileLine(filehandle,Line,sizeof(Line));
		TrimString(Line);
		if(Line[0] == '/' || Line[0] == '\0') continue;
		if (StrContains(Line,".mp3",false) != -1 || StrContains(Line,".wav",false) != -1)
		{
			if (StrContains(Line,"=") != -1)
			{
				ExplodeString(Line,"=",Text,2,256);
				for (new t = 0; t < sizeof(Team1); t++) {
					if (!strcmp(Text[1],Team1[t],false)) {
						MaxSounds++;
						g_soundsList[MaxSounds] = Text[0];
		
						MaxSoundsT++;
						g_soundsListT[MaxSoundsT] = Text[0];
					}
				}
				for (new t = 0; t < sizeof(Team2); t++) {
					if (!strcmp(Text[1],Team2[t],false)) {
						MaxSounds++;
						g_soundsList[MaxSounds] = Text[0];
		
						MaxSoundsCT++;
						g_soundsListCT[MaxSoundsCT] = Text[0];
					}
				}
				if(!strcmp(Text[1],"BOTH",false) || !strcmp(Text[1],"",false))
				{
					MaxSounds++;
					g_soundsList[MaxSounds] = Text[0];
		
					MaxSoundsT++;
					g_soundsListT[MaxSoundsT] = Text[0];
				
					MaxSoundsCT++;
					g_soundsListCT[MaxSoundsCT] = Text[0];
				}
			}
			else
			{
					Format(Text2, sizeof(Text2), Line);
					MaxSounds++;
					g_soundsList[MaxSounds] = Text2;
		
					MaxSoundsT++;
					g_soundsListT[MaxSoundsT] = Text2;
				
					MaxSoundsCT++;
					g_soundsListCT[MaxSoundsCT] = Text2;
			}
		}
		else if (!StrEqual(Line, ""))
		{
			LogError("Invalid sound - %s", Line);
			LogError("Sounds should be only \".mp3\" or \".wav\"");
		}
	}
	CloseHandle(filehandle);
	LogMessage("General %d sounds loaded", MaxSounds);
	if (game == GAME_CSTRIKE)
	{
		LogMessage("Of them %d sounds loaded for Terrorist team", MaxSoundsT);
		LogMessage("And %d sounds loaded for Counter-Terrorist team", MaxSoundsCT);
	}
	else
	{
		LogMessage("Of them %d sounds loaded for team 1", MaxSoundsT);
		LogMessage("And %d sounds loaded for team 2", MaxSoundsCT);
	}
}

public Action:ResCmd(client, args) {
	decl String:buffer[PLATFORM_MAX_PATH];
	
	if(res_sound[client] != 0) {
		res_sound[client] = 0;
		PrintToChat(client, "\x04[\x01RoundEndSound\x04] %t", "Res Off");
	}
	else {
		res_sound[client] = 1;
		PrintToChat(client, "\x04[\x01RoundEndSound\x04] %t", "Res On");
	}
	
	IntToString(res_sound[client], buffer, 5);
	SetClientCookie(client, cookieResPref, buffer);
}

public Action:TimerEvery(Handle:timer) {
	if(!roundEnded && GetConVarBool(AnnounceEvery)) PrintToChatAll("\x04[\x01RoundEndSound\x04] %t", "Announce Message", YELLOW, GREEN, YELLOW, GREEN);
}

public ResPrefSelected(client, CookieMenuAction:action, any:info, String:buffer[], maxlen) {
	if (action == CookieMenuAction_DisplayOption)
	{
		decl String:status[10];
		if (res_sound[client] != 0) Format(status, sizeof(status), "%T", "On", client);
		else Format(status, sizeof(status), "%T", "Off", client);
		Format(buffer, maxlen, "%T: %s", "Cookie Round End Sound", client, status);
	}
	else
	{
		if(res_sound[client] != 0) res_sound[client] = 0;
		else res_sound[client] = 1;
		ShowCookieMenu(client);
	}
}

public OnClientPutInServer(client) {
	if(!IsFakeClient(client)) {
		if(AreClientCookiesCached(client)) loadClientCookiesFor(client);
		if(GetConVarBool(OnPlayerConnect)) CreateTimer(20.0, TimerAnnounce, client);
	}
}

loadClientCookiesFor(client)
{
	new String:buffer[5];
	GetClientCookie(client, cookieResPref, buffer, 5);
	if(!StrEqual(buffer, "")) res_sound[client] = StringToInt(buffer);
	else res_sound[client] = 1;
}

public PrepareSound(sound) {
	new String:downloadFile[PLATFORM_MAX_PATH];

	Format(downloadFile, sizeof(downloadFile), "sound/%s", g_soundsList[sound]);
	if(!FileExists(downloadFile,true) && !FileExists(downloadFile,false))
	{
		LogError("[Round End Sound] File not found - %s" , g_soundsList[sound]);
		return;
	}
	PrecacheSound(g_soundsList[sound], true);
	AddFileToDownloadsTable(downloadFile);
}

public Action:TimerAnnounce(Handle:timer, any:client) {
	if(IsClientInGame(client)) PrintToChat(client, "\x04[\x01RoundEndSound\x04] %t", "Announce Message", YELLOW, GREEN, YELLOW, GREEN);
}

public OnClientCookiesCached(client) {
	if(IsClientInGame(client) && !IsFakeClient(client)) loadClientCookiesFor(client);
}